export type TableOptions = {
    name: string;
    key?: string;
};
export declare class Database {
    readonly database: string;
    version?: number | undefined;
    connection: Promise<IDBDatabase>;
    tables: TableOptions[];
    constructor(database: string, tables: (string | TableOptions)[], version?: number | undefined);
    includes(name: any): boolean;
    table<K extends IDBValidKey = any, T = any>(name: any): Table<K, T>;
}
export declare class Table<K extends IDBValidKey = any, T = any> {
    private readonly database;
    readonly name: string;
    constructor(database: Database, name: string);
    tx<R>(table: string, fn: (store: IDBObjectStore) => IDBRequest, readonly?: boolean): Promise<R>;
    add(value: T, key?: K): Promise<void>;
    count(): Promise<number>;
    put(key: K, value: T): Promise<void>;
    getAll(): Promise<T[]>;
    getAllKeys(): Promise<K[]>;
    get(key: K): Promise<T>;
    delete(key: K): Promise<void>;
    clear(): Promise<void>;
}
